/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	scheme "quark.netapp.io/volume-controller/pkg/client/clientset/versioned/scheme"
)

// NetAppStoragePoolsGetter has a method to return a NetAppStoragePoolInterface.
// A group's client should implement this interface.
type NetAppStoragePoolsGetter interface {
	NetAppStoragePools(namespace string) NetAppStoragePoolInterface
}

// NetAppStoragePoolInterface has methods to work with NetAppStoragePool resources.
type NetAppStoragePoolInterface interface {
	Create(ctx context.Context, netAppStoragePool *v1alpha1.NetAppStoragePool, opts v1.CreateOptions) (*v1alpha1.NetAppStoragePool, error)
	Update(ctx context.Context, netAppStoragePool *v1alpha1.NetAppStoragePool, opts v1.UpdateOptions) (*v1alpha1.NetAppStoragePool, error)
	UpdateStatus(ctx context.Context, netAppStoragePool *v1alpha1.NetAppStoragePool, opts v1.UpdateOptions) (*v1alpha1.NetAppStoragePool, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.NetAppStoragePool, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NetAppStoragePoolList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppStoragePool, err error)
	NetAppStoragePoolExpansion
}

// netAppStoragePools implements NetAppStoragePoolInterface
type netAppStoragePools struct {
	client rest.Interface
	ns     string
}

// newNetAppStoragePools returns a NetAppStoragePools
func newNetAppStoragePools(c *QuarkV1alpha1Client, namespace string) *netAppStoragePools {
	return &netAppStoragePools{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the netAppStoragePool, and returns the corresponding netAppStoragePool object, and an error if there is any.
func (c *netAppStoragePools) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NetAppStoragePool, err error) {
	result = &v1alpha1.NetAppStoragePool{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappstoragepools").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of NetAppStoragePools that match those selectors.
func (c *netAppStoragePools) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NetAppStoragePoolList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.NetAppStoragePoolList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappstoragepools").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested netAppStoragePools.
func (c *netAppStoragePools) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("netappstoragepools").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a netAppStoragePool and creates it.  Returns the server's representation of the netAppStoragePool, and an error, if there is any.
func (c *netAppStoragePools) Create(ctx context.Context, netAppStoragePool *v1alpha1.NetAppStoragePool, opts v1.CreateOptions) (result *v1alpha1.NetAppStoragePool, err error) {
	result = &v1alpha1.NetAppStoragePool{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("netappstoragepools").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppStoragePool).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a netAppStoragePool and updates it. Returns the server's representation of the netAppStoragePool, and an error, if there is any.
func (c *netAppStoragePools) Update(ctx context.Context, netAppStoragePool *v1alpha1.NetAppStoragePool, opts v1.UpdateOptions) (result *v1alpha1.NetAppStoragePool, err error) {
	result = &v1alpha1.NetAppStoragePool{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("netappstoragepools").
		Name(netAppStoragePool.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppStoragePool).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *netAppStoragePools) UpdateStatus(ctx context.Context, netAppStoragePool *v1alpha1.NetAppStoragePool, opts v1.UpdateOptions) (result *v1alpha1.NetAppStoragePool, err error) {
	result = &v1alpha1.NetAppStoragePool{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("netappstoragepools").
		Name(netAppStoragePool.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppStoragePool).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the netAppStoragePool and deletes it. Returns an error if one occurs.
func (c *netAppStoragePools) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappstoragepools").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *netAppStoragePools) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappstoragepools").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched netAppStoragePool.
func (c *netAppStoragePools) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppStoragePool, err error) {
	result = &v1alpha1.NetAppStoragePool{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("netappstoragepools").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
